using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using TIS.Imaging;

namespace Image_Processing
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        /// <summary>
        /// Form_load
        ///
        /// foCXݒ_CAO\AG[ bZ[Wh߂ɗL
        /// JfoCX`FbN܂B
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        /// 
        //<<Form1_Load
        private void Form1_Load( object sender, EventArgs e )
        {

            if( !icImagingControl1.LoadShowSaveDeviceState("lastSelectedDeviceState.xml") )
            {
                MessageBox.Show("No device was selected.", this.Text, MessageBoxButtons.OK, MessageBoxIcon.Information);
                this.Close();
                return;
            }
            // J̐ݒ肵𑜓xɍ킹ĕ\ʂύX
            icImagingControl1.LiveDisplayDefault = false;
            icImagingControl1.LiveDisplaySize = icImagingControl1.Size;

            cmdStartLive.Enabled = true;
            cmdStopLive.Enabled = false;
            cmdProcess.Enabled = false;
        }


        Form _displayForm = null;

        /// <summary>
        /// cmdProcess_Click
        ///
        /// P̉摜XibvA摜f[^𔽓]ăobt@\܂B
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
		//<<cmd_process
        private void cmdProcess_Click( object sender, EventArgs e )
        {
            //}EX|C^ꎞIɑҋ@ԁiʏ͍ṽACRjɂ
            Cursor = Cursors.WaitCursor;
            try
            {
                //Î~ۑ@\gݍ܂ꂽSink^CvFrameSnapSinkgp
                FrameSnapSink sink = icImagingControl1.Sink as FrameSnapSink;
                //J瑗ꂽV摜擾̂҂A擾ꂽ IFrameQueueBufferɂ̉摜Ԃ܂
                IFrame imgBuffer = sink.SnapSingle( TimeSpan.FromSeconds( 5 ) );

                //t[̃^Cv擾
                var frameType = imgBuffer.FrameType;

                unsafe
                {
                    //摜f[^ւ̃|C^[Ԃ܂B
                    byte* pDatabyte = imgBuffer.Ptr;
                    for( int y = 0; y < frameType.Height; y++ )
                    {
                        for( int x = 0; x < frameType.BytesPerLine; x++ )
                        {
                            //Pxl𔽓]
                            *pDatabyte = (byte)(255 - *pDatabyte);
                            pDatabyte++;
                        }
                    }
                }

                //tB[ȂΐVtH[쐬
                if( _displayForm == null || _displayForm.IsDisposed )
                {
                    _displayForm = new Form();
                }

                //Pxl𔽓]摜tH[ɃRs[\
                _displayForm.BackgroundImage = imgBuffer.CreateBitmapCopy();
                _displayForm.Size = frameType.Size;
                _displayForm.Show();
            }
            catch( Exception ex )
            {
                MessageBox.Show( ex.Message );
            }
            //}EX|C^ʏɖ߂
            Cursor = Cursors.Default;
        }

        private void cmdStopLive_Click( object sender, EventArgs e )
        {
            icImagingControl1.LiveStop();

            cmdStartLive.Enabled = true;
            cmdStopLive.Enabled = false;
            cmdProcess.Enabled = false;
        }


        //<<cmd_StartLive
        private void cmdStartLive_Click_1( object sender, EventArgs e )
        {
            // ̃Tv̓J[摜ŋ@\邽߁AVN^Cv RGB24 ɐݒ肵܂B
            icImagingControl1.Sink = new TIS.Imaging.FrameSnapSink(MediaSubtypes.RGB24);

            icImagingControl1.LiveStart();

            cmdStartLive.Enabled = false;
            cmdStopLive.Enabled = true;
            cmdProcess.Enabled = true;
        }
        //>>

    }
}